<%@ page import="java.io.*,java.util.*, javax.servlet.*" %><%@ page import="javax.servlet.http.*" %><%@ page import="org.apache.commons.fileupload.*" %><%@ page import="org.apache.commons.fileupload.disk.*" %><%@ page import="org.apache.commons.fileupload.servlet.*" %><%@ page import="org.apache.commons.io.output.*" %><%@ page import="wfr.com.*,wfr.sys.*,wfr.sys.HTMLInterface.*, wfr.rules.WFRAvailableRuleType"%><%@ page import="java.util.*"%><%@ page import="wfr.exceptions.*"%><%@ page import="wfr.util.Logger" %><%@ page import="java.io.PrintWriter"%><%@ page import="wfr.util.Functions"%><%@ page import="wfr.util.WFRConfig"%><%@ page import="wfr.util.Resources"%><%@ page import="wfr.util.JS"%><%@ page import="java.util.*"%><%@ page import="java.sql.Timestamp"%><%@ page import="java.sql.Types"%><%@ page import="wfr.database.*"%><%@ page import="wfr.exceptions.*"%><%
	String contentType = request.getContentType();
	int maxFileSize = 10;
	int maxFiles = 5;

	Resources resources = Resources.getInstance(request);
	Logger logger = Logger.getLogger(this.getClass());
	WFRSystem system = null;
	AccessType access = null;
	String sys = request.getParameter("sys");
	String formId = request.getParameter("formId");
	HTMLInterface htmlInterface = null;
	HTMLAction action = null;

	String parametros = request.getParameter("parametros");
	java.util.List parametrosItens = null;
	try {
		parametrosItens = (java.util.List) br.com.l2software.api.utils.JsonUtils.jsonToObject(parametros);
	} catch (Exception ex) {
	}
	String ruleName = request.getParameter("aoReceberArquivo");

	String resizeWidth = null;
	String resizeHeight = null;
	boolean autoProcessQueue = true;
	boolean batchProcess = false;
	String acceptedFiles = "";
	List<String> filtroExtensoes = new ArrayList<String>();
	try {
		Map<String, Object> extrasMap = br.com.l2software.api.dropzone.ClientHelper.getExtras(request);
		if(extrasMap.containsKey("TAMANHO_LIMITE")) {
			String v = String.valueOf(extrasMap.get("TAMANHO_LIMITE"));
			maxFileSize = Integer.valueOf(v);
		}
		if(extrasMap.containsKey("IMAGEM_LARGURA")) {
			String v = String.valueOf(extrasMap.get("IMAGEM_LARGURA"));
			resizeWidth = v;
		}
		if(extrasMap.containsKey("IMAGEM_ALTURA")) {
			String v = String.valueOf(extrasMap.get("IMAGEM_ALTURA"));
			resizeHeight = v;
		}
		if(extrasMap.containsKey("QUANTIDADE_LIMITE")) {
			String v = String.valueOf(extrasMap.get("QUANTIDADE_LIMITE"));
			maxFiles = Integer.valueOf(v);
		}
		if(extrasMap.containsKey("ENVIO_AUTOMATICO")) {
			String ENVIO_AUTOMATICO = String.valueOf(extrasMap.get("ENVIO_AUTOMATICO"));
			autoProcessQueue = "S".equalsIgnoreCase(ENVIO_AUTOMATICO) || "t".equalsIgnoreCase(ENVIO_AUTOMATICO)|| "true".equalsIgnoreCase(ENVIO_AUTOMATICO) || 
								"sim".equalsIgnoreCase(ENVIO_AUTOMATICO) || "1".equalsIgnoreCase(ENVIO_AUTOMATICO) || "yes".equalsIgnoreCase(ENVIO_AUTOMATICO) ||
								"y".equalsIgnoreCase(ENVIO_AUTOMATICO);
		}
		if(extrasMap.containsKey("ENVIO_AGRUPADO")) {
			String ENVIO_AGRUPADO = String.valueOf(extrasMap.get("ENVIO_AGRUPADO"));
			batchProcess = "S".equalsIgnoreCase(ENVIO_AGRUPADO) || "t".equalsIgnoreCase(ENVIO_AGRUPADO)|| "true".equalsIgnoreCase(ENVIO_AGRUPADO) || 
								"sim".equalsIgnoreCase(ENVIO_AGRUPADO) || "1".equalsIgnoreCase(ENVIO_AGRUPADO) || "yes".equalsIgnoreCase(ENVIO_AGRUPADO) ||
								"y".equalsIgnoreCase(ENVIO_AGRUPADO);
		}
		if(extrasMap.containsKey("FILTRO_MIME")) {
			acceptedFiles = String.valueOf(extrasMap.get("FILTRO_MIME"));
		}
		if(extrasMap.containsKey("FILTRO_EXTENSAO")) {
			Object FILTRO_EXTENSAO = extrasMap.get("FILTRO_EXTENSAO");
			if(FILTRO_EXTENSAO instanceof List) {
				for(Object vFiltro: (List) FILTRO_EXTENSAO) {
					filtroExtensoes.add(String.valueOf(vFiltro).toLowerCase());
				}
			} else {
				for(String vFiltro: String.valueOf(FILTRO_EXTENSAO).split(",")) {
					filtroExtensoes.add(vFiltro.toLowerCase());
				}
			}
		}
	} catch (Exception ex) {
		//Ignore
	}
	int maxMemSize = maxFileSize * 1024 * 1024;
	if ((contentType != null) && (contentType.indexOf("multipart/form-data") >= 0)) {
		htmlInterface = HTMLInterface.getInstance(request);   
		wfr.sys.WFRData data = htmlInterface.getData();
		access = htmlInterface.getAccess();
		system = htmlInterface.getSystem();
		request.setAttribute("sys", system);
		request.setAttribute("userName", htmlInterface.getUser());
		wfr.database.DBConnection conn;
		boolean closeConn = false;
		if(htmlInterface.getData() == null) {
			conn = htmlInterface.getSystem().getNewDBConnection();
			closeConn = true;
		} else {
			conn = htmlInterface.getData().connection();
		}

		String filePath = wfr.util.WFRConfig.dir() + "/tmp/";

		DiskFileItemFactory factory = new DiskFileItemFactory();
		factory.setSizeThreshold(maxMemSize);
		factory.setRepository(new File(filePath));
		ServletFileUpload upload = new ServletFileUpload(factory);
		upload.setHeaderEncoding("UTF-8");
		upload.setSizeMax( maxFileSize * 1024 * 1024);
		try{ 
			List<String> arquivos = new ArrayList<String>();
			List fileItems = upload.parseRequest(request);
			Iterator i = fileItems.iterator();
			while (i.hasNext ()) 
			{
				FileItem fi = (FileItem)i.next();
				if (!fi.isFormField()) {
					String fieldName = fi.getFieldName();
					String fileName = fi.getName();
					fileName = br.com.l2software.api.utils.StrUtils.removerAcentos(fileName);
					boolean isInMemory = fi.isInMemory();
					long sizeInBytes = fi.getSize();
					File file = new File(filePath + java.util.UUID.randomUUID().toString() + "-" + fileName.replaceAll("[\\\\/]", "_").replaceAll("\\.\\.", "__"));
					fi.write(file);
					arquivos.add(file.getAbsolutePath());
				}
			}
			
			List<Object> itens = new ArrayList<Object>();
			if(batchProcess) {
				itens.add(arquivos);
			} else {
				itens.addAll(arquivos);
			}

			//java.io.PrintWriter pOut = new java.io.PrintWriter(out);
			java.io.StringWriter outWriter = new java.io.StringWriter();
			java.io.PrintWriter pOut = new java.io.PrintWriter(outWriter);
			wfr.com.WFRForm wfrForm = system.getForm(formId, conn);
			wfr.database.WFRResultSet wfrResultSet = (wfr.database.WFRResultSet) data.getFormResultSet(formId, request);
			wfr.sys.WFRFormData wfrFormData = new wfr.sys.WFRFormData(wfrResultSet, request, wfrForm, data, pOut);

			for(Object fItem: itens) {
				try {
					wfr.rules.Variant[] paramsArray = new wfr.rules.Variant[2];
					paramsArray[0] = wfr.rules.VariantPool.get(fItem);
					paramsArray[1] = wfr.rules.VariantPool.get(parametrosItens);
					wfr.rules.WFRRuleClient client = new wfr.rules.WFRRuleClient(system, data, pOut, request);
					wfr.rules.WFRRule rule = system.getRuleManager().getRuleClass(ruleName, client, conn, wfrFormData, false);
					try {
						if (conn != null) {
							conn.startTransactionIfNecessary();
						}

						wfr.rules.Variant rResult = rule.start(paramsArray);
						if (conn != null) {
							conn.commitTransaction();
							conn.closeConnection();
						}
						out.print(outWriter.toString());
					} catch (Exception execEx) {
						if (conn != null) {
							conn.rollbackTransaction();
							conn.closeConnection();
						}
						execEx.printStackTrace();
						throw execEx;
					}
				} catch (wfr.exceptions.WFRRuleException wfrEx) {
					response.setStatus (412);
					out.write(wfrEx.getShowMessage(null));
					//wfrEx.printStackTrace(new java.io.PrintWriter(out));
				} catch (Exception ruleEx) {
					response.setStatus (500);
					out.write("ERRO DESCONHECIDO.");
					//ruleEx.printStackTrace(new java.io.PrintWriter(out));
				}
			}
		} catch(Exception ex) {
			System.out.println(ex);
		}
		if(closeConn) {
			conn.closeConnection();
		}
	} else {  
		out.println("<!--No file uploaded-->"); 
		%>
<html>
<head>
	<!--[if IE]><base href="<% 
	String baseURL = request.getRequestURL().toString().replace("/l2s/dropzone/index.jsp", "/");
	out.print(baseURL); %>"></base><![endif]-->
	<!--[if !IE]>--><base href="../.." /><!--<![endif]-->
<script src="l2s/dropzone/dropzone.js"></script>
<script>
Dropzone.options.filesUp = {
	paramName: "file", // The name that will be used to transfer the file
	maxFilesize: <%=maxFileSize%>, // MB
	uploadMultiple: <%=(maxFiles > 1) ? "true" : "false"%>,
	parallelUploads: <%=String.valueOf(maxFiles)%>,
	maxFiles: <%=String.valueOf(maxFiles)%>,
	autoProcessQueue: <%=autoProcessQueue ? "true" : "false"%>,
	resizeWidth: <%=resizeWidth%>,
	resizeHeight: <%=resizeHeight%>,
	resizeQuality: 1.0,
	addRemoveLinks: true,
	<%if(!"".equals(acceptedFiles.trim())) {
		out.println("acceptedFiles: '" + acceptedFiles + "',\n"); 
	}%>
	<%if(filtroExtensoes.size() > 0) {%>
	accept: function(file, done) {
		var fName = file.name.toLowerCase();
		<%for(String vFiltro: filtroExtensoes) {%>
			if(fName.endsWith(".<%=vFiltro%>")) {
				done();
				return;
			}
		<%}%>
		done('Arquivo com extenso no permitida: ' + fName);
	},
  <%}%>
  dictDefaultMessage: "<img src=\"l2s/dropzone/dropfiles.png\"><br/><br/>Arraste aqui os arquivos que deseja enviar.",
  dictInvalidFileType: "Tipo de arquivo no permitido.",
  dictFileTooBig: "O arquivo tem o tamanho ({{filesize}}) maior que o limite permitido ({{maxFilesize}}).",
  dictCancelUpload: "Cancelar envio.",
  dictRemoveFile: 'Remover',
  dictCancelUploadConfirmation: "Deseja realmente cancelar o envio?",
  dictMaxFilesExceeded: "Quantidade excedida.",
  error: function(file, message) {
		//Remover apos error
		file.previewElement.addEventListener("click", function() {
			var filesUp = Dropzone.forElement("#filesUp");
			filesUp.removeFile(file);
		});
		setTimeout(function() {  var filesUp = Dropzone.forElement("#filesUp"); filesUp.removeFile(file); }, 15000);

		var idx = message.indexOf("XXXXXXXXXX//-->");
		if(idx > 0) {
			message = '<!--' + message.substring(idx);
			var code = "var div = document.createElement('div');" + 
					"div.innerHTML = " + JSON.stringify(message) + ';' +
					"for(var idx = 0; idx < div.children.length; idx++) { eval(div.children[idx].innerText); };";
			window.parent.eval.apply(window.parent, [code]);
		} else {
			var node, _i, _len, _ref, _results;
			if (file.previewElement) {
			  file.previewElement.classList.add("dz-error");
			  if (typeof message !== "String" && message.error) {
				message = message.error;
			  }
			  _ref = file.previewElement.querySelectorAll("[data-dz-errormessage]");
			  _results = [];
			  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
				node = _ref[_i];
				_results.push(node.textContent = message);
			  }
		  }
          return _results;
        }
		return [];
      },
  success: function(file, serverResponse) {
		var idx = serverResponse.indexOf("XXXXXXXXXX//-->");
		if(idx > 0) {
			serverResponse = '<!--' + serverResponse.substring(idx);
		}
		var code = "var div = document.createElement('div');" + 
					"div.innerHTML = " + JSON.stringify(serverResponse) + ';' +
					"for(var idx = 0; idx < div.children.length; idx++) { eval(div.children[idx].innerText); };";
		window.parent.eval.apply(window.parent, [code]);
		if (file.previewElement) {
			file._removeLink.style.display = 'none';
			return file.previewElement.classList.add("dz-success");
		}
		return true;
	}
};
<%=br.com.l2software.api.dropzone.ClientHelper.getJS(request)%>
</script>
<link rel="stylesheet" href="l2s/dropzone/dropzone.css">
<style>
body {
	height: <%=request.getParameter("height")%>px;
}

.dropzone {
	padding: 0px;
}

#fileZone {
	height: <%=request.getParameter("height")%>px;
}

#filesUp {
	min-height: calc(100% - 16px);
}
<%
	String parametro = org.apache.commons.lang.StringEscapeUtils.escapeHtml(request.getParameter("parametros"));
	parametro = parametro.replaceAll("\\\"", "&quote;");
	String extras = org.apache.commons.lang.StringEscapeUtils.escapeHtml(request.getParameter("extras"));
	extras = extras.replaceAll("\\\"", "&quote;");
%>
</style>
</head>
<body>
<div id="fileZone">
<%
StringBuilder queryParams = new StringBuilder();
for (java.util.Map.Entry<?, ?> entry : ((java.util.Map<?, ?>) request.getParameterMap()).entrySet()) {
	String name = String.valueOf(entry.getKey());
    String value = String.valueOf((entry.getValue() instanceof String[]) ? ((String[]) entry.getValue())[0] : entry.getValue());
	queryParams.append(name);
	queryParams.append("=");
	queryParams.append(java.net.URLEncoder.encode(value));
	queryParams.append("&");
}
%>
<form id="filesUp" action="l2s/dropzone/index.jsp?<%=queryParams.toString()%>" method="POST" enctype="multipart/form-data" class="dropzone">
	<input type="hidden" name="sys" value="<%=sys%>" />
	<input type="hidden" name="formId" value="<%=request.getParameter("formId")%>" />
	<input type="hidden" name="aoReceberArquivo" value="<%=request.getParameter("aoReceberArquivo")%>" />
	<input type="hidden" name="parametros" value="<%=parametro%>" />
	<input type="hidden" name="extras" value="<%=extras%>" />
</form>
</div>
<script>
	var fUp = {
		removeAllFiles: function(values) {
			var filesUp = Dropzone.forElement("#filesUp");
			filesUp.removeAllFiles(true);
		},
		processQueue: function() {
			var filesUp = Dropzone.forElement("#filesUp");
			filesUp.processQueue();
		}
	};
	document.body._dropzone = fUp;
	document._dropzone = fUp;
	window._dropzone = fUp;
	
	window.addEventListener("dragenter", function(e){
		e = e || event;
		e.preventDefault();
		return false;
	  }, false);
	  window.addEventListener("dragover", function(e){
		e = e || event;
		e.preventDefault();
		return false;
	  }, false);
	  window.addEventListener("drop", function(e){
		e = e || event;
		e.preventDefault();
		return false;
	  }, false);
</script>
</body>
</html>
<%
}
%>